{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: main.PAS, released on 25 April 2003.

The Initial Developer of the Original Code is Alexey Nikitayev [nikitayev@rsu.ru]
All Rights Reserved.

Contributor(s):

Last Modified: 25 April 2003

You may retrieve the latest version of this file at the Project Opencomputer's home page,
located at http://opencomputer.narod.ru/

Known Issues:


-----------------------------------------------------------------------------}
unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, RXShell, AppEvent, Menus, Buttons, StdCtrls,
  RxNotify, Placemnt, ExtCtrls, ComCtrls, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdMessageClient, IdSMTP, Mask, ToolEdit,
  IdMessage, IdPOP3,
  Utils, MPlayer;

const
   Path:string = '';
   PathCommon = 'common';
   PathSend0 = 'send txt';
   PathSendMDG = 'send mdg';
   PathSendTHR = 'send thr';
   PathRecvPAC = 'recv pac';
   PathRecvDAT = 'recv dat';

type
  TOnFileSend = function (const DirSrc,DirDest,FileName:string;ShowErrors:boolean):boolean of object;
  TRecvTypes = (rt_Unknown,rt_PAC,rt_DAT);

  TMainForm = class(TForm)
    RxTrayIcon1: TRxTrayIcon;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    RxMonitor: TRxFolderMonitor;
    FormPlacement1: TFormPlacement;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Memo1: TMemo;
    N3: TMenuItem;
    Label7: TLabel;
    ComboBox1: TComboBox;
    Timer_0: TTimer;
    IdMessage: TIdMessage;
    POP: TIdPOP3;
    TabSheet3: TTabSheet;
    PageControl2: TPageControl;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    ScrollBox1: TScrollBox;
    Label1: TLabel;
    Label8: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label11: TLabel;
    Edit1: TEdit;
    DirectoryEdit2: TDirectoryEdit;
    DirectoryEdit1: TDirectoryEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit8: TEdit;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    TabSheet8: TTabSheet;
    ScrollBox2: TScrollBox;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Edit9: TEdit;
    DirectoryEdit3: TDirectoryEdit;
    DirectoryEdit4: TDirectoryEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    ScrollBox3: TScrollBox;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Edit15: TEdit;
    DirectoryEdit5: TDirectoryEdit;
    DirectoryEdit6: TDirectoryEdit;
    Edit16: TEdit;
    Edit17: TEdit;
    Edit18: TEdit;
    Edit19: TEdit;
    Edit20: TEdit;
    ScrollBox4: TScrollBox;
    ScrollBox5: TScrollBox;
    DirectoryEdit7: TDirectoryEdit;
    Label29: TLabel;
    DirectoryEdit8: TDirectoryEdit;
    Label30: TLabel;
    DirectoryEdit9: TDirectoryEdit;
    DirectoryEdit10: TDirectoryEdit;
    GroupBox1: TGroupBox;
    Edit22: TEdit;
    GroupBox3: TGroupBox;
    Label9: TLabel;
    Edit6: TEdit;
    Label10: TLabel;
    Edit7: TEdit;
    GroupBox2: TGroupBox;
    Label31: TLabel;
    Label34: TLabel;
    Edit23: TEdit;
    Edit24: TEdit;
    GroupBox4: TGroupBox;
    Label35: TLabel;
    Label36: TLabel;
    Edit25: TEdit;
    Edit26: TEdit;
    Label37: TLabel;
    Edit27: TEdit;
    Label38: TLabel;
    Edit28: TEdit;
    Label39: TLabel;
    Edit29: TEdit;
    Label40: TLabel;
    Edit30: TEdit;
    GroupBox5: TGroupBox;
    Label41: TLabel;
    Edit31: TEdit;
    Label42: TLabel;
    Edit32: TEdit;
    Label43: TLabel;
    Edit33: TEdit;
    Label44: TLabel;
    Edit34: TEdit;
    Label45: TLabel;
    Edit35: TEdit;
    GroupBox6: TGroupBox;
    Label46: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    Label49: TLabel;
    Label50: TLabel;
    Edit36: TEdit;
    Edit37: TEdit;
    Edit38: TEdit;
    Edit39: TEdit;
    Edit40: TEdit;
    GroupBox7: TGroupBox;
    Edit21: TEdit;
    SendMDG: TBitBtn;
    CancelMDG: TBitBtn;
    Send0: TBitBtn;
    CancelSend0: TBitBtn;
    CancelSMTP: TBitBtn;
    BitBtn6: TBitBtn;
    RecvPAC: TBitBtn;
    CancelPAC: TBitBtn;
    RecvDAT: TBitBtn;
    CancelDAT: TBitBtn;
    SendTHR: TBitBtn;
    CancelTHR: TBitBtn;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    MonitorMDG: TRxFolderMonitor;
    MonitorTHR: TRxFolderMonitor;
    IdMessageMDG: TIdMessage;
    IdMessageTHR: TIdMessage;
    Timer_MDG: TTimer;
    Timer_THR: TTimer;
    Timer_recv: TTimer;
    Timer_DAT: TTimer;
    POP_PAC: TIdPOP3;
    POP_DAT: TIdPOP3;
    IdMessage_PAC: TIdMessage;
    IdMessage_DAT: TIdMessage;
    Label28: TLabel;
    Label32: TLabel;
    GroupBox8: TGroupBox;
    Label33: TLabel;
    SoundFilename: TFilenameEdit;
    MediaPlayer: TMediaPlayer;
    Edit41: TEdit;
    Label51: TLabel;
    Label52: TLabel;
    Edit42: TEdit;
    procedure BitBtn6Click(Sender: TObject);
    procedure CancelDATClick(Sender: TObject);
    procedure CancelMDGClick(Sender: TObject);
    procedure CancelPACClick(Sender: TObject);
    procedure CancelSend0Click(Sender: TObject);
    procedure CancelSMTPClick(Sender: TObject);
    procedure CancelTHRClick(Sender: TObject);
    procedure DirectoryEdit2Change(Sender: TObject);
    procedure DirectoryEdit3Change(Sender: TObject);
    procedure DirectoryEdit5Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure MonitorMDGChange(Sender: TObject);
    procedure MonitorTHRChange(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure RecvDATClick(Sender: TObject);
    procedure RecvPACClick(Sender: TObject);
    procedure RxMonitorChange(Sender: TObject);
    procedure RxTrayIcon1Click(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
    procedure Send0Click(Sender: TObject);
    procedure SendMDGClick(Sender: TObject);
    procedure SendTHRClick(Sender: TObject);
    procedure Timer_0Timer(Sender: TObject);
    procedure Timer_MDGTimer(Sender: TObject);
    procedure Timer_THRTimer(Sender: TObject);
    procedure Timer_recvTimer(Sender: TObject);
    procedure Timer_DATTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    UserExit:boolean;
    HasError:boolean;
    HasError_MDG:boolean;
    HasError_THR:boolean;
    procedure InitFolderName;
    function GetDesktopPath:string;
    function SendEmail (ShowErrors:boolean;ApplyFileChanges:TOnFileSend;
        Msg:TIdMessage;Monitor:TRxFolderMonitor;
        const FileMask,FolderTo,From,Recipient,Org,Subject,Body:string):boolean;
    function SendSimple(const DirSrc,DirDest,FileName:string;ShowErrors:boolean):boolean;
    function SendFileMDG(const DirSrc,DirDest,FileName:string;ShowErrors:boolean):boolean;
    procedure PushMemo;
    procedure SaveAllSettings;
    procedure Run;
  end;

var
  MainForm: TMainForm;

implementation
uses INIFiles,Registry;

{$R *.dfm}

procedure TMainForm.RxTrayIcon1Click(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  MainForm.Visible:=true;
  MainForm.Enabled:=true;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caHide;
  MainForm.Visible:=false;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  MainForm.Hide;
  CanClose:=UserExit;
end;

procedure TMainForm.N2Click(Sender: TObject);
begin
  UserExit:=true;
  SaveAllSettings;
  Close;
end;

procedure TMainForm.N1Click(Sender: TObject);
begin
  MainForm.Visible:=true;
  MainForm.Enabled:=true;
end;

procedure TMainForm.RxMonitorChange(Sender: TObject);
begin
  HasError:=not SendEmail(not HasError,SendSimple,IdMessage,RxMonitor,
            Edit1.Text,DirectoryEdit1.Text,Edit2.Text,
            Edit3.Text,Edit4.Text,Edit5.Text,Edit8.Text);
  Timer_0.Enabled:=HasError;          
end;

procedure TMainForm.InitFolderName;
begin
  CancelSMTPClick(nil);
  CancelMDGClick(nil);
  CancelSend0Click(nil);
  CancelPACClick(nil);
  CancelDATClick(nil);
  CancelTHRClick(nil);
end;

procedure TMainForm.N3Click(Sender: TObject);
begin
  RxMonitorChange(nil);
  MonitorMDGChange(nil);
  MonitorTHRChange(nil);
  if Timer_recv.Enabled then
    Timer_recvTimer(nil);
end;

procedure TMainForm.Timer_0Timer(Sender: TObject);
begin
  RxMonitorChange(nil);
  if not HasError then Timer_0.Enabled:=false;
  PushMemo;
end;

procedure TMainForm.DirectoryEdit2Change(Sender: TObject);
begin
  RxMonitor.FolderName:=DirectoryEdit2.Text;
end;

procedure TMainForm.DirectoryEdit3Change(Sender: TObject);
begin
  MonitorMDG.FolderName:=DirectoryEdit3.Text;
end;

procedure TMainForm.DirectoryEdit5Change(Sender: TObject);
begin
  MonitorTHR.FolderName:=DirectoryEdit5.Text;
end;

procedure TMainForm.BitBtn6Click(Sender: TObject);
var INI:TINIFile;
begin
  INI:=TIniFile.Create(Path);
  INI.WriteString(PathCommon,'MIME type',ComboBox1.Text);
  INI.WriteString(PathCommon,'SMTP server',Edit6.Text);
  INI.WriteString(PathCommon,'SMTP server port',Edit7.Text);
  INI.WriteString(PathCommon,'sound',SoundFilename.Text);
  FreeAndNil(INI);
end;

procedure TMainForm.Send0Click(Sender: TObject);
var INI:TINIFile;
begin
  INI:=TINIFile.Create(Path);
  INI.WriteString(PathSend0,' ',Edit1.Text);
  INI.WriteString(PathSend0,' ',DirectoryEdit2.Text);
  INI.WriteString(PathSend0,' ',DirectoryEdit1.Text);
  INI.WriteString(PathSend0,'From',Edit2.Text);
  INI.WriteString(PathSend0,'To',Edit3.Text);
  INI.WriteString(PathSend0,'Organization',Edit4.Text);
  INI.WriteString(PathSend0,'Subject',Edit5.Text);
  INI.WriteString(PathSend0,'Body',Edit8.Text);
  FreeAndNil(INI);
end;

procedure TMainForm.SendMDGClick(Sender: TObject);
var INI:TINIFile;
begin
  INI:=TINIFile.Create(Path);
  INI.WriteString(PathSendMDG,' ',Edit9.Text);
  INI.WriteString(PathSendMDG,' ',DirectoryEdit3.Text);
  INI.WriteString(PathSendMDG,' ',DirectoryEdit4.Text);
  INI.WriteString(PathSendMDG,'From',Edit10.Text);
  INI.WriteString(PathSendMDG,'To',Edit11.Text);
  INI.WriteString(PathSendMDG,'Organization',Edit12.Text);
  INI.WriteString(PathSendMDG,'Subject',Edit13.Text);
  INI.WriteString(PathSendMDG,'Body',Edit14.Text);
  FreeAndNil(INI);
end;

procedure TMainForm.RecvPACClick(Sender: TObject);
var INI:TINIFile;
begin
  INI:=TINIFile.Create(Path);
  INI.WriteString(PathRecvPAC,'',DirectoryEdit7.Text);
  INI.WriteString(PathRecvPAC,' ',DirectoryEdit8.Text);
  INI.WriteString(PathRecvPAC,'Server mail account',Edit21.Text);
  INI.WriteString(PathRecvPAC,'POP3 server',Edit23.Text);
  INI.WriteString(PathRecvPAC,'POP3 server port',Edit24.Text);
  INI.WriteString(PathRecvPAC,'Login',Edit27.Text);
  INI.WriteString(PathRecvPAC,'Password',EncodeStr(Edit28.Text));

  INI.WriteString(PathRecvPAC,'From',Edit31.Text);
  INI.WriteString(PathRecvPAC,'To',Edit32.Text);
  INI.WriteString(PathRecvPAC,'Organization',Edit33.Text);
  INI.WriteString(PathRecvPAC,'Subject',Edit34.Text);
  INI.WriteString(PathRecvPAC,'Body',Edit35.Text);

  INI.WriteString(PathRecvPAC,'',Edit42.Text);
  FreeAndNil(INI);
end;

procedure TMainForm.RecvDATClick(Sender: TObject);
var INI:TINIFile;
begin
  INI:=TINIFile.Create(Path);
  INI.WriteString(PathRecvDAT,'',DirectoryEdit9.Text);
  INI.WriteString(PathRecvDAT,' ',DirectoryEdit10.Text);
  INI.WriteString(PathRecvDAT,'Server mail account',Edit22.Text);
  INI.WriteString(PathRecvDAT,'POP3 server',Edit25.Text);
  INI.WriteString(PathRecvDAT,'POP3 server port',Edit26.Text);
  INI.WriteString(PathRecvDAT,'Login',Edit29.Text);
  INI.WriteString(PathRecvDAT,'Password',EncodeStr(Edit30.Text));

  INI.WriteString(PathRecvDAT,'From',Edit36.Text);
  INI.WriteString(PathRecvDAT,'To',Edit37.Text);
  INI.WriteString(PathRecvDAT,'Organization',Edit38.Text);
  INI.WriteString(PathRecvDAT,'Subject',Edit39.Text);
  INI.WriteString(PathRecvDAT,'Body',Edit40.Text);

  INI.WriteString(PathRecvDAT,'',Edit41.Text);
  FreeAndNil(INI);
end;

procedure TMainForm.SendTHRClick(Sender: TObject);
var INI:TINIFile;
begin
  INI:=TINIFile.Create(Path);
  INI.WriteString(PathSendTHR,' ',Edit15.Text);
  INI.WriteString(PathSendTHR,' ',DirectoryEdit5.Text);
  INI.WriteString(PathSendTHR,' ',DirectoryEdit6.Text);
  INI.WriteString(PathSendTHR,'From',Edit16.Text);
  INI.WriteString(PathSendTHR,'To',Edit17.Text);
  INI.WriteString(PathSendTHR,'Organization',Edit18.Text);
  INI.WriteString(PathSendTHR,'Subject',Edit19.Text);
  INI.WriteString(PathSendTHR,'Body',Edit20.Text);
  FreeAndNil(INI);
end;

procedure TMainForm.CancelSMTPClick(Sender: TObject);
var INI:TINIFile;
begin
  INI:=TINIFile.Create(Path);
  Edit6.Text:=INI.ReadString(PathCommon,'SMTP server','smtp.aaanet.ru');
  Edit7.Text:=INI.ReadString(PathCommon,'SMTP server port','25');
  ComboBox1.Text:=INI.ReadString(PathCommon,'MIME type','8bit');
  SoundFilename.Text:=INI.ReadString(PathCommon,'sound',ExtractFilePath(Application.ExeName)+'Trumpet1.wav');

  if not FileExists(SoundFilename.Text) then
    if SoundFilename.Dialog.Execute then
      INI.WriteString(PathCommon,'sound',SoundFilename.Dialog.FileName);

  MediaPlayer.FileName:=SoundFilename.Text;
  FreeAndNil(INI);
end;

procedure TMainForm.CancelSend0Click(Sender: TObject);
var INI:TINIFile;
begin
  INI:=TINIFile.Create(Path);
  DirectoryEdit1.Text:=INI.ReadString(PathSend0,' ','c:\temp');
  DirectoryEdit2.Text:=INI.ReadString(PathSend0,' ','');
  Edit1.Text:=INI.ReadString(PathSend0,' ','*.txt');
  Edit2.Text:=INI.ReadString(PathSend0,'From','');
  Edit3.Text:=INI.ReadString(PathSend0,'To','');
  Edit4.Text:=INI.ReadString(PathSend0,'Organization','');
  Edit5.Text:=INI.ReadString(PathSend0,'Subject','');
  Edit8.Text:=INI.ReadString(PathSend0,'Body','');
  FreeAndNil(INI);
  if DirectoryEdit2.Text='' then
  begin
    DirectoryEdit2.Text:=GetDesktopPath;
  end;
  RxMonitor.FolderName:=DirectoryEdit2.Text;
end;


function TMainForm.GetDesktopPath: string;
var INI:TRegINIFile;
begin
try
  result:='';
  INI:=TRegINIFile.Create('Software\Microsoft\Windows\CurrentVersion\Explorer\Shell folders',KEY_READ);
  result:=INI.ReadString('','Desktop','');
finally
  FreeAndNil(INI);
end;  
end;

procedure TMainForm.CancelMDGClick(Sender: TObject);
var INI:TINIFile;
begin
  INI:=TINIFile.Create(Path);
  DirectoryEdit3.Text:=INI.ReadString(PathSendMDG,' ','c:\temp');
  DirectoryEdit4.Text:=INI.ReadString(PathSendMDG,' ','c:\temp');
  Edit9.Text:=INI.ReadString(PathSendMDG,' ','*.mdg');
  Edit10.Text:=INI.ReadString(PathSendMDG,'From','');
  Edit11.Text:=INI.ReadString(PathSendMDG,'To','');
  Edit12.Text:=INI.ReadString(PathSendMDG,'Organization','');
  Edit13.Text:=INI.ReadString(PathSendMDG,'Subject','');
  Edit14.Text:=INI.ReadString(PathSendMDG,'Body','');
  FreeAndNil(INI);
  if DirectoryEdit3.Text='' then
  begin
    DirectoryEdit3.Text:=GetDesktopPath;
  end;
  MonitorMDG.FolderName:=DirectoryEdit3.Text;
end;

procedure TMainForm.CancelTHRClick(Sender: TObject);
var INI:TINIFile;
begin
  INI:=TINIFile.Create(Path);
  DirectoryEdit5.Text:=INI.ReadString(PathSendTHR,' ','c:\temp');
  DirectoryEdit6.Text:=INI.ReadString(PathSendTHR,' ','c:\temp');
  Edit15.Text:=INI.ReadString(PathSendTHR,' ','*.thr');
  Edit16.Text:=INI.ReadString(PathSendTHR,'From','');
  Edit17.Text:=INI.ReadString(PathSendTHR,'To','');
  Edit18.Text:=INI.ReadString(PathSendTHR,'Organization','');
  Edit19.Text:=INI.ReadString(PathSendTHR,'Subject','');
  Edit20.Text:=INI.ReadString(PathSendTHR,'Body','');
  FreeAndNil(INI);
  if DirectoryEdit5.Text='' then
  begin
    DirectoryEdit5.Text:=GetDesktopPath;
  end;
  MonitorTHR.FolderName:=DirectoryEdit5.Text;
end;

procedure TMainForm.CancelPACClick(Sender: TObject);
var INI:TINIFile;
begin
  INI:=TINIFile.Create(Path);
  DirectoryEdit7.Text:=INI.ReadString(PathRecvPAC,'','c:\temp');
  DirectoryEdit8.Text:=INI.ReadString(PathRecvPAC,' ','c:\temp');
  Edit21.Text:=INI.ReadString(PathRecvPAC,'Server mail account','');
  Edit23.Text:=INI.ReadString(PathRecvPAC,'POP3 server','');
  Edit24.Text:=INI.ReadString(PathRecvPAC,'POP3 server port','110');
  Edit27.Text:=INI.ReadString(PathRecvPAC,'Login','');
  Edit28.Text:=DecodeStr(INI.ReadString(PathRecvPAC,'Password',''));

  Edit31.Text:=INI.ReadString(PathRecvPAC,'From','');
  Edit32.Text:=INI.ReadString(PathRecvPAC,'To','');
  Edit33.Text:=INI.ReadString(PathRecvPAC,'Organization','');
  Edit34.Text:=INI.ReadString(PathRecvPAC,'Subject','');
  Edit35.Text:=INI.ReadString(PathRecvPAC,'Body','');

  Edit42.Text:=INI.ReadString(PathRecvPAC,'','*.pac');
  FreeAndNil(INI);
end;

procedure TMainForm.CancelDATClick(Sender: TObject);
var INI:TINIFile;
begin
  INI:=TINIFile.Create(Path);
  DirectoryEdit9.Text:=INI.ReadString(PathRecvDAT,'','c:\temp');
  DirectoryEdit10.Text:=INI.ReadString(PathRecvDAT,' ','c:\temp');
  Edit22.Text:=INI.ReadString(PathRecvDAT,'Server mail account','');
  Edit25.Text:=INI.ReadString(PathRecvDAT,'POP3 server','');
  Edit26.Text:=INI.ReadString(PathRecvDAT,'POP3 server port','110');
  Edit29.Text:=INI.ReadString(PathRecvDAT,'Login','');
  Edit30.Text:=DecodeStr(INI.ReadString(PathRecvDAT,'Password',''));

  Edit36.Text:=INI.ReadString(PathRecvDAT,'From','');
  Edit37.Text:=INI.ReadString(PathRecvDAT,'To','');
  Edit38.Text:=INI.ReadString(PathRecvDAT,'Organization','');
  Edit39.Text:=INI.ReadString(PathRecvDAT,'Subject','');
  Edit40.Text:=INI.ReadString(PathRecvDAT,'Body','');

  Edit41.Text:=INI.ReadString(PathRecvDAT,'','*.dat');
  FreeAndNil(INI);
end;

function TMainForm.SendEmail(ShowErrors:boolean;ApplyFileChanges:TOnFileSend;
        Msg:TIdMessage;Monitor:TRxFolderMonitor;
        const FileMask,FolderTo,From,Recipient,Org,Subject,Body:string):boolean;
var
  sr: TSearchRec;
  FileAttrs: Integer;
  SMTP:TIdSMTP;
begin
  result:=true;
  FileAttrs := faArchive;

  try
    if FindFirst(Monitor.FolderName+'\'+FileMask, FileAttrs, sr) = 0 then
    begin
      repeat

          Msg.Date:=Now;
          Msg.From.Text:=From;
          Msg.ReplyTo.EMailAddresses:=From;
          Msg.Organization:=Org;
          Msg.Recipients.EMailAddresses:=Recipient;
          Msg.Subject:=Subject;
          Msg.IsEncoded:=true;
          Msg.ContentTransferEncoding:=Combobox1.Text;
          Msg.Body.Clear;
          Msg.Body.Add(Body);
          Msg.MessageParts.Clear;
          TIdAttachment.Create(Msg.MessageParts,Monitor.FolderName+'\'+sr.Name);

            SMTP:=TIdSMTP.Create(nil);
            SMTP.MailAgent:='Postman <nikitayev@rsu.ru>';
            SMTP.Host:=Edit6.Text;
            SMTP.Port:=StrToInt(Edit7.Text);
            SMTP.Connect;
            SMTP.Send(Msg);
            SMTP.Disconnect;
            FreeAndNil(SMTP);

          Memo1.Lines.Add(TimeToStr(Now)+'  '+sr.Name+' ');

        result:=ApplyFileChanges(Monitor.FolderName,FolderTo,sr.Name,ShowErrors);

      until FindNext(sr) <> 0;

      FindClose(sr);
    end;

  except
    on E:Exception do
        begin
          if not HasError then ShowMessage(E.Message);
          Memo1.Lines.Add(': <'+E.Message+'> :'+TimeToStr(Now));
          result:=false;
          FreeAndNil(SMTP);
        end;
  end;

end;

procedure TMainForm.MonitorMDGChange(Sender: TObject);
begin
HasError_MDG:=not SendEmail(not HasError_MDG,
  SendFileMDG,
  IdMessageMDG,
  MonitorMDG,
  Edit9.Text,
  DirectoryEdit4.Text,
  Edit10.Text,
  Edit11.Text,
  Edit12.Text,
  Edit13.Text,
  Edit14.Text
  );
  Timer_MDG.Enabled:=HasError;
end;

procedure TMainForm.MonitorTHRChange(Sender: TObject);
begin
HasError_THR:=not SendEmail(not HasError_THR,
  SendSimple,
  IdMessageTHR,
  MonitorTHR,
  Edit15.Text,
  DirectoryEdit6.Text,
  Edit16.Text,
  Edit17.Text,
  Edit18.Text,
  Edit19.Text,
  Edit20.Text
  );

  Timer_THR.Enabled:=HasError;
end;

function TMainForm.SendSimple(const DirSrc, DirDest,
  FileName: string;ShowErrors:boolean): boolean;
begin
result:=true;

 if not DirectoryExists(DirDest) then
   if not ForceDirectories(DirDest) then
   begin
     if ShowErrors then ShowMessage('      <'+DirDest+'>');
     Memo1.Lines.Add(TimeToStr(Now)+'    <'+FileName+'>'+#10#13+
       '          <'+DirDest+'>' );
     result:=false;
     exit;
   end;

 if not RenameFile(DirSrc+'\'+FileName,
          DirDest+'\'+FileName) then
   begin
     if ShowErrors then
       if MessageDlg(' <'+DirDest+'\'+FileName+'>  . ?',
           mtConfirmation, [mbYes, mbNo], 0) = mrYes then
         begin
           DeleteFile(DirDest+'\'+FileName);
           RenameFile(DirSrc+'\'+FileName,
             DirDest+'\'+FileName);
         end;
     Memo1.Lines.Add(TimeToStr(Now)+'   <'+DirDest+'\'+FileName+'>  .');
     result:=false;
   end;
end;

function TMainForm.SendFileMDG(const DirSrc, DirDest, FileName: string;
  ShowErrors: boolean): boolean;
var FS:TFileStream;
    NewFN:string;
    Size:byte;
    Family,Name,Surname:string;
begin
result:=false;

  FS:=TFileStream.Create(DirSrc+'\'+FileName,fmOpenRead,fmShareDenyWrite);
  FS.Position:=$832;

  FS.ReadBuffer(Size,1);
  SetLength(Family,Size);
  FS.ReadBuffer(Family[1],Size);
  FS.Position:=FS.Position+4;

  FS.ReadBuffer(Size,1);
  SetLength(Name,Size);
  FS.ReadBuffer(Name[1],Size);
  FS.Position:=FS.Position+4;

  FS.ReadBuffer(Size,1);
  SetLength(Surname,Size);
  FS.ReadBuffer(Surname[1],Size);

  FreeAndNil(FS);

  NewFN:=DirDest+'\'+RusFormatAsName(Family)+' '+RusFormatAsName(Name)+
         ' '+RusFormatAsName(Surname);
  if ForceDirectories(NewFN) then
    result:=SendSimple(DirSrc,NewFN,FileName,ShowErrors);
end;

procedure TMainForm.PushMemo;
var i:Integer;
begin
  if Memo1.Lines.Count>200 then
    for i:=50 downto 0 do
      Memo1.Lines.Delete(i);
end;

procedure TMainForm.Timer_MDGTimer(Sender: TObject);
begin
  MonitorMDGChange(nil);
  if not HasError then Timer_MDG.Enabled:=false;
  PushMemo;
end;

procedure TMainForm.Timer_THRTimer(Sender: TObject);
begin
  MonitorTHRChange(nil);
  if not HasError then Timer_THR.Enabled:=false;
  PushMemo;
end;

procedure TMainForm.Timer_recvTimer(Sender: TObject);
var
    i,j,NumMsg:Integer;
    FS:TFileStream;
    Att:TIdAttachment;
    NewFN:string;
    Size:byte;
    Family,Name,Surname:string;
    FNSrc,FNDest:PChar;
    LocalErr:boolean;
    SMTP:TIdSMTP;
    Loaded:boolean;
    Recvd:boolean;
    Recv_type:TRecvTypes;
begin

//start checking
  Timer_recv.Enabled:=false;

  POP_PAC.Password:=Edit28.Text;
  POP_PAC.Username:=Edit27.Text;
  POP_PAC.Port:=StrToInt(Edit24.Text);
  POP_PAC.Host:=Edit23.Text;

  try

    try
      POP_PAC.Connect;
    except
      Timer_recv.Enabled:=true;
      LocalErr:=true;
      exit;
    end;

    NumMsg:=POP_PAC.CheckMessages;

    Recvd:=false;


    for i:=1 to NumMsg do
    begin
      Loaded:=false;
      LocalErr:=false;
      IdMessage_PAC.Clear;
      POP_PAC.RetrieveHeader(i,IdMessage_PAC);
      if not AnsiSameText(IdMessage_PAC.From.Address,Edit21.Text) then continue;

      IdMessage_PAC.Clear;
      POP_PAC.Retrieve(i,IdMessage_PAC);
      for j:=IdMessage_PAC.MessageParts.Count-1  downto 1 do
      begin
        Att:=TIdAttachment(IdMessage_PAC.MessageParts[j]);
        if ExtractFileExt(Att.FileName)=ExtractFileExt(Edit42.Text) then
          Recv_type:=rt_PAC else
        if ExtractFileExt(Att.FileName)=ExtractFileExt(Edit41.Text) then
          Recv_type:=rt_DAT else
          begin
            Recv_type:=rt_Unknown;
            continue;
          end;

          Loaded:=true;
          Recvd:=true;

          try
            case Recv_type of
              rt_PAC:Att.SaveToFile(DirectoryEdit7.Text+'\'+Att.FileName);
              rt_DAT:Att.SaveToFile(DirectoryEdit9.Text+'\'+Att.FileName);
            end;  
          except
            LocalErr:=true;
            Memo1.Lines.Add(TimeToStr(Now)+'  :     '+
                            Att.FileName);
            Continue;
          end;

        //find Family,Name,Surname
        try
          case Recv_type of
            rt_PAC:
              begin
                FS:=TFileStream.Create(DirectoryEdit7.Text+'\'+Att.FileName,
                                       fmOpenRead,fmShareDenyWrite);
                FS.Position:=$82E;

                FS.ReadBuffer(Size,1);
                SetLength(Family,Size);
                FS.ReadBuffer(Family[1],Size);
                FS.Position:=FS.Position+4;

                FS.ReadBuffer(Size,1);
                SetLength(Name,Size);
                FS.ReadBuffer(Name[1],Size);
                FS.Position:=FS.Position+4;

                FS.ReadBuffer(Size,1);
                SetLength(Surname,Size);
                FS.ReadBuffer(Surname[1],Size);

                FreeAndNil(FS);
              end;
            rt_DAT:
              begin
                FS:=TFileStream.Create(DirectoryEdit9.Text+'\'+Att.FileName,fmOpenRead,fmShareDenyWrite);
                FS.Position:=$8;

                FS.ReadBuffer(Size,1);
                SetLength(Name,Size);
                FS.ReadBuffer(Name[1],Size);

                FreeAndNil(FS);
            end;
          end;
        except
          LocalErr:=true;
          FreeAndNil(FS);
          Memo1.Lines.Add(TimeToStr(Now)+'  :     '+
                          Att.FileName);
          Continue;
        end;

        //save in other directory
        case Recv_type of
          rt_PAC:NewFN:=DirectoryEdit7.Text;
          rt_DAT:NewFN:=DirectoryEdit9.Text;
        end;  
        if ForceDirectories(NewFN) then
        begin
          FNSrc:=PChar(NewFN+'\'+Att.FileName);
          case Recv_type of
            rt_PAC:NewFN:=DirectoryEdit8.Text+'\'+RusFormatAsName(Family)+' '+
                          RusFormatAsName(Name)+' '+RusFormatAsName(Surname);
            rt_DAT:NewFN:=DirectoryEdit10.Text+'\'+Name;
          end;
          ForceDirectories(NewFN);
          FNDest:=PChar(NewFN+'\'+Att.FileName);
          if CopyFile(FNSrc,FNDest,false) then
            Memo1.Lines.Add(TimeToStr(Now)+'  '+Att.FileName+' ')
            else
              Memo1.Lines.Add(TimeToStr(Now)+'  :'+Att.FileName+
              '    '+
              '   '+NewFN+' ,       ');
        end;

    //send answer
    with IdMessage_DAT do
    case Recv_type of
      rt_PAC:
        begin
          From.Text:=Edit31.Text;
          ReplyTo.EMailAddresses:=Edit31.Text;
          Organization:=Edit33.Text;
          Recipients.EMailAddresses:=Edit32.Text;
          Subject:=Edit34.Text+'  : <'+IdMessage_PAC.Subject+'>  '+
                   DateTimeToStr(IdMessage_PAC.Date);
          Body.Clear;
          Body.Add(Edit35.Text);
          MessageParts.Clear;
        end;
      rt_DAT:
        begin
          From.Text:=Edit36.Text;
          ReplyTo.EMailAddresses:=Edit36.Text;
          Organization:=Edit38.Text;
          Recipients.EMailAddresses:=Edit37.Text;
          Subject:=Edit39.Text+'  : <'+IdMessage_PAC.Subject+'>  '+
                   DateTimeToStr(IdMessage_DAT.Date);
          Body.Clear;
          Body.Add(Edit40.Text);
          MessageParts.Clear;
        end;
    end;

    try
      SMTP:=TIdSMTP.Create(nil);
      SMTP.MailAgent:='Postman <nikitayev@rsu.ru>';
      SMTP.Host:=Edit6.Text;
      SMTP.Port:=StrToInt(Edit7.Text);
      SMTP.Connect;
      SMTP.Send(IdMessage_DAT);
      SMTP.Disconnect;
      FreeAndNil(SMTP);
    except
      FreeAndNil(SMTP);
      Memo1.Lines.Add(TimeToStr(Now)+'  :      '+Att.FileName);
    end;
    
      end;
      //IdMessage_PAC.MessageParts.Clear;
      if (not LocalErr) and Loaded then
      //for i:=NumMsg downto 1 do
      begin
        POP_PAC.Delete(i);
      end;

    end;


  finally
    Timer_recv.Enabled:=true;
    if (NumMsg>0) then
      if not LocalErr then
      begin
        if Recvd then
        begin
          MediaPlayer.Open;
          MediaPlayer.Play;
          //SysUtils.Beep;
        end;
      end  else
        SysUtils.Beep;

    POP_PAC.Disconnect;
  end;
//end checking

end;

procedure TMainForm.Timer_DATTimer(Sender: TObject);
var
    i,j,NumMsg:Integer;
    FS:TFileStream;
    Att:TIdAttachment;
    NewFN:string;
    Size:byte;
    FullName:string;
    FNSrc,FNDest:PChar;
    LocalErr:boolean;
    SMTP:TIdSMTP;
    Loaded:boolean;
    Recvd:boolean;
begin

//start checking
  //Timer_DAT.Enabled:=false;

  POP_DAT.Password:=Edit30.Text;
  POP_DAT.Username:=Edit29.Text;
  POP_DAT.Port:=StrToInt(Edit26.Text);
  POP_DAT.Host:=Edit25.Text;

  try

    try
      POP_DAT.Connect;
    except
      Timer_DAT.Enabled:=true;
      LocalErr:=true;
      exit;
    end;

    NumMsg:=POP_DAT.CheckMessages;

    Recvd:=false;
    for i:=NumMsg downto 1 do
    begin
      Loaded:=false;
      POP_DAT.RetrieveHeader(i,IdMessage_DAT);
      if not AnsiSameText(IdMessage_DAT.From.Address,Edit22.Text) then continue;

      POP_DAT.Retrieve(i,IdMessage_DAT);
      for j:=1 to IdMessage_DAT.MessageParts.Count-1 do
      begin
        Att:=TIdAttachment(IdMessage_DAT.MessageParts[j]);
        if ExtractFileExt(Att.FileName)<>ExtractFileExt(Edit41.Text) then continue;
        Loaded:=true;
        Recvd:=true;

        try
          Att.SaveToFile(DirectoryEdit9.Text+'\'+Att.FileName);
        except
          LocalErr:=true;
          Memo1.Lines.Add(TimeToStr(Now)+'  :     '+Att.FileName);
          Continue;
        end;

        //find Family,Name,Surname
        try
          FS:=TFileStream.Create(DirectoryEdit9.Text+'\'+Att.FileName,fmOpenRead,fmShareDenyWrite);
          FS.Position:=$8;

          FS.ReadBuffer(Size,1);
          SetLength(FullName,Size);
          FS.ReadBuffer(FullName[1],Size);

          FreeAndNil(FS);
        except
          LocalErr:=true;
          FreeAndNil(FS);
          Memo1.Lines.Add(TimeToStr(Now)+'  :     '+Att.FileName);
          Continue;
        end;

        //save in other directory

        NewFN:=DirectoryEdit9.Text;
        if ForceDirectories(NewFN) then
        begin
          FNSrc:=PChar(DirectoryEdit9.Text+'\'+Att.FileName);
            NewFN:=DirectoryEdit10.Text+'\'+FullName;
            ForceDirectories(NewFN);
          FNDest:=PChar(NewFN+'\'+Att.FileName);
          if CopyFile(FNSrc,FNDest,false) then
            Memo1.Lines.Add(TimeToStr(Now)+'  '+Att.FileName+' ')
            else
              Memo1.Lines.Add(TimeToStr(Now)+'  :'+Att.FileName+'    '+
              '   '+NewFN+' ,       ');
        end;

    //send answer
    with IdMessage_DAT do
    begin
      From.Text:=Edit36.Text;
      ReplyTo.EMailAddresses:=Edit36.Text;
      Organization:=Edit38.Text;
      Recipients.EMailAddresses:=Edit37.Text;
      Subject:=Edit39.Text+'  : <'+IdMessage_DAT.Subject+'>  '+
               DateTimeToStr(IdMessage_DAT.Date);
      Body.Clear;
      Body.Add(Edit40.Text);
      MessageParts.Clear;
    end;

    try
      SMTP:=TIdSMTP.Create(nil);
      SMTP.MailAgent:='Postman <nikitayev@rsu.ru>';
      SMTP.Host:=Edit6.Text;
      SMTP.Port:=StrToInt(Edit7.Text);
      SMTP.Connect;
      SMTP.Send(IdMessage_DAT);
      SMTP.Disconnect;
      FreeAndNil(SMTP);
    except
      FreeAndNil(SMTP);
      Memo1.Lines.Add(TimeToStr(Now)+'  :      '+Att.FileName);
    end;

       
      end;
      if (not LocalErr) and Loaded then POP_DAT.Delete(i);
      IdMessage_DAT.MessageParts.Clear;
    end;  


  finally
    Timer_DAT.Enabled:=true;
    if (NumMsg>0) then
      if not LocalErr then
      begin
        if Recvd then
        begin
        MediaPlayer.Open;
        MediaPlayer.Play;
        end;
      end  else
        SysUtils.Beep;
    POP_DAT.Disconnect;
  end;
//end checking

end;

procedure TMainForm.SaveAllSettings;
begin
  BitBtn6Click(nil);
  Send0Click(nil);
  SendMDGClick(nil);
  SendTHRClick(nil);
  RecvPACClick(nil);
  RecvDATClick(nil);
end;

procedure TMainForm.Run;
begin
  RxMonitorChange(nil);
  MonitorMDGChange(nil);
  MonitorTHRChange(nil);
end;

initialization
  Path:=ExtractFilePath(Application.ExeName)+'Postman.ini';
end.
